# Report a bug

You found a bug in MQTT433gateway? Please open a new issue for it on our issue tracker.

Please provide the following points in your issue:
- Which MQTT433gateway version (or git hash) do you use?
- Which platformio environment are you using?
- Can you reproduce your issue? If yes, how? Make sure the issue includes clear steps to reproduce the bug so we can reproduce it.


# Contribute code

Pull requests are even better than issues. We gladly accept pull requests.

For a pull request please consider:
- Format the code using `clang-format` and the style configuration
`.clang-format` provided by this project. `scripts/stylecheck -c` can show you required changes.
- If your pull request fixes a bug, make sure the issue includes clear steps to reproduce the bug so we can test your fix. If the issue already exist please refer to it.
- Break up your PR into multiple commits, at logical break points. If possible, one commit per file and feature.
- Have a look to the travis CI results.
- Make sure your email address in the commits is linked to your github account.
- Use meaningful commit messages (have a look to the history for examples)
  - Each commit message should start with the module or file it affects.
  - Write the summary line and description of what you have done in the imperative mode that is as if you were commanding someone. Start the line with "Fix", "Add", "Change" instead of "Fixed", "Added", "Changed".

With any pull request you sign-off of the following:
- That you wrote the change yourself, or took it from a project with a compatible license (in the latter case the commit message, and possibly source code should provide reference where the implementation was taken from and give credit to the original author, as required by the license).
- That you are allowed to release these changes to an open-source project
- That you agree to release the changes under MQTT433gateway's license, which is the MIT license.


# Announce

You like MQTT433gateway and you have a blog? It would be great if you could write a small post about MQTT433gateway.
